// You should not make any modifications to this class!

/**
 * <CODE>NoCurrentException</CODE>s are issued by several methods in the 
 * <CODE>LLSequence</CODE> class to indicate that the LLSequence currently 
 * contains no values.
 *
 * Note that <CODE>NoCurrentException</CODE> is an <i>unchecked</i> exception 
 * (because it is a subclass of <CODE>RuntimeException</CODE>).
 * 
 * @see LLSequence
 **/
public class NoCurrentException extends RuntimeException {

    /**
     * Creates a new <CODE>NoCurrentException</CODE> with no error message.
     **/
    public NoCurrentException() {
        super();
    }

    
    /**
     * Creates a new <CODE>NoCurrentException</CODE> with the specified error 
     * message.
     *
     * @param message the detailed error message
     **/
    public NoCurrentException(String message) {
        super(message);
    }
}
