/*******************************************************************************
Title:            Linked Lists 
Files:            PhotoAlbum.java, Photo.java, LLSequence.java, DoubleNode.java, 
                  NoCurrentException.java, CWHelp.java

Author:            Data Fok, data@cs.wisc.edu
Collaborators:    N/A

Due Date:         Friday, March 2, 2001
Completion Date:  2-27-2001

Course:           CS367, Spring 2001, Section 3
Assignment:       Programming Assignment 2 

Editor:           CodeWarrior
Compiler:         CodeWarrior (JDK 1.2)
Platform:         Unix (Solaris)
*******************************************************************************/

import java.io.*;

// This file contains a main method which indicates how you should
// perform all I/O operations for this project.  Note that the main
// method is not complete: you should fill in the bodies of all if
// statements, and may have to add some local variables.

public class PhotoAlbum {

    public PhotoAlbum() { //constructor
    	
    }
    
    public static void main(String [] args) throws IOException {
        final String NEW = "new";
        final String ADD_FRONT = "addInFront";
        final String ADD_BACK = "addInBack";
        final String REMOVE = "removePhoto";
        final String FLIP_FORWARD = "flipForward";
        final String FLIP_BACKWARD = "flipBackward";
        final String CHANGE = "changeCaption";
        final String FIND = "findPhoto";
        final String PRINT = "printAlbum";
        final String ER_EMPTY = " - the photo album is empty"; //error message
   	LLSequence myAlbum = null;     
        

    // put the whole code around a try/catch/finally block so can keep window around
    // the indenting is off for this because only the CW Unix version needs this
    try { 
        // Only run the program if there is one command line argument
        if (args.length != 1) {
            System.err.println("usage: java <input file name>");
            return;
        }

        // Create the object to read from a file
        BufferedReader fin = new BufferedReader(new FileReader(args[0]));
        
        // parse every line of the input file
        while(fin.ready()) {
            String line = fin.readLine();
                        
            // Fill in all if bodies appropriately
            if (line.equals(NEW)) {
		myAlbum = new LLSequence();
            }//end NEW
            else if (line.equals(ADD_FRONT)) {
                // get the file name and date taken
                String fileName = fin.readLine();
                int dateTaken = Integer.parseInt(fin.readLine());
		// create a new photo with the file name and date taken
		Photo myPhoto = new Photo(fileName, dateTaken);
		// add the photo to the photo album
		myAlbum.addBefore(myPhoto);
	    }//end ADD_FRONT
            else if (line.equals(ADD_BACK)) {
                // get the file name and date taken
                String fileName = fin.readLine();
                int dateTaken = Integer.parseInt(fin.readLine());
                // create a new photo with the file name and data taken
                Photo myPhoto = new Photo(fileName, dateTaken);
                // add the photo to the photo album
		myAlbum.addAfter(myPhoto);
            }//end ADD_BACK
            else if (line.equals(REMOVE)) {
	   	try {
	   	   //remove the current photo showing in the photo album
	   	   myAlbum.removeCurrent();
            	} catch (NoCurrentException e) { //if photo album empty
            	   System.out.println("\nCannot remove photo" + ER_EMPTY);
		}            
            }//end REMOVE
            else if (line.equals(FLIP_FORWARD)) {
                // get the number of times to flip
                int times = Integer.parseInt(fin.readLine());
		try {
	   	   //filp forward the album for the given amount of times
	   	   myAlbum.advance(times);
            	} catch (NoCurrentException e) { //if photo album empty
            	   System.out.println("\nCannot Flip forward " + ER_EMPTY);
		} 
            }//end FLIP_FORWARD
            else if (line.equals(FLIP_BACKWARD)) {
                // get the number of times to flip
                int times = Integer.parseInt(fin.readLine());
		try {
	   	   //filp backward the album for the given amount of times
	   	   myAlbum.back(times);
            	} catch (NoCurrentException e) { //if photo album empty
            	   System.out.println("\nCannot Flip backward " + ER_EMPTY);
		} 
            }//end FLIP_BACKWARD
            else if (line.equals(CHANGE)) {
                // get the new caption
                String caption = fin.readLine();
                try {
	   	   //get the current photo
	   	   Photo tempPhoto = (Photo) ( (DoubleNode) myAlbum.getCurrent() ) .data;
	   	   // change the caption of the current photo
	   	   tempPhoto.setCaption(caption);
            	} catch (NoCurrentException e) { //if photo album empty
            	   System.out.println("\nCannot Change Caption " + ER_EMPTY);
		} 
            }//end CHANGE
            else if (line.equals(FIND)) {
                // get the file name and date taken
                String fileName = fin.readLine();
                int dateTaken = Integer.parseInt(fin.readLine());
                // create a photo with the file name and date taken of the photo being searched
                Photo lookPhoto = new Photo(fileName, dateTaken);
                if ( !(myAlbum.lookup(lookPhoto) ) ) { //if the photo album does not contain the photo
                	System.out.println("\nThe photo album does not contain " + 
                	     lookPhoto.toString() );
            	}
            }//end FIND
            else if (line.equals(PRINT)) {
		if (myAlbum.size() ==0 ) //if the photo album is empty
			System.out.println("\nThe photo album is empty");
		else {
		   	try {
	   	  		// print all the photo in the album with the current point back to the 
	   	  		// same photo after the print
	   	  		System.out.println( "\nPhotoAlbum contents:");
	   	  		for ( int i = 0 ; i < myAlbum.size() ; i++ ) {
	   	  			Photo printPhoto = (Photo) ( (DoubleNode) myAlbum.getCurrent() ).data;
	   	  			System.out.println( printPhoto.toString() );
	   	  			myAlbum.advance();
	   	  		}//end for
            		} catch (NoCurrentException e) {
            	  		System.out.println("\nCannot print photo album " + ER_EMPTY);
			}
		} 
            }//end PRINT
            // simply ignore all other input by doing nothing else

        } // closes while

        // Always make sure you close the input files
        fin.close();
        } catch (Throwable ex) {
            System.err.println("PhotoAlbum had uncaught exception in main");
            ex.printStackTrace();
        }  finally {
            CWHelp.keepWindow();
        } 
    }
      
}


