/*******************************************************************************
Main Class File:  MazeSolver.java
File:			  ListNode.java	             

Author:           Data Fok, data@cs.wisc.edu
Collaborators:    N/A

Completion Date:  3-25-2001

Course:           CS367, Spring 2001, Section 3
Assignment:       Programming Assignment 3 

Editor:           CodeWarrior
Compiler:       CodeWarrior (JDK 1.2)
Platform:         Unix (Solaris)
*******************************************************************************/

/**
 * The <CODE>ListNode</CODE> class is used as a storage object for data.
 * It further keeps track of the next ListNodes in the sequence
 * with the use of <CODE>next</CODE> ListNode data
 * members, which is accessible package-wide.
 **/
class ListNode {

    // Note: All data members have package-wide access.

    /**
     * The data this node is keeping track of.
     **/
    Object data;
    
    /**
     * The node following this ListNode.  If there is no such node,
     * <CODE>next</CODE> should have the value <CODE>null</CODE>.  
     **/
    ListNode next;


    /**
     * Creates a new, completely empty ListNode.  The data and next
     * references are all set to <CODE>null</CODE>.
     **/
    public ListNode() {
        this(null);
    }


    /**
     * Creates a new ListNode which contains the specified data.
     * The next references is set to <CODE>null</CODE>.
     * 
     * @param data the data being stored in this ListNode
     **/
    public ListNode(Object data) {
        this(data, null);
    }


    /**
     * Creates a new ListNode which contains the specified data with
     * specified next reference.
     *
     * @param data the data being stored in this ListNode
     * @param next the node to follow this ListNode
     **/
    public ListNode(Object data, ListNode next) {
        this.data = data;
        this.next = next;
    }
    
    
    /**
     * Returns a String representation of this ListNode.  Returns the String
     * given by the toString() method of the data of this node.
     *
     * @return a String representation of this ListNode
     **/
    public String toString() {
        return data.toString();
    }
}