/*******************************************************************************
Main Class File:  MazeSolver.java
File:			  Stack.java	             

Author:           Data Fok, data@cs.wisc.edu
Collaborators:    N/A

Completion Date:  3-25-2001
Course:           CS367, Spring 2001, Section 3
Assignment:       Programming Assignment 3 

Editor:           CodeWarrior
Compiler:       CodeWarrior (JDK 1.2)
Platform:         Unix (Solaris)
*******************************************************************************/
// You must add data members as well as fill in all method bodies.  If you wish,
// you may add private methods and other constructors, but you should not add 
// any other public methods.

/**
 * A Stack is a LIFO (Last In, First Out) data structure:  only the most 
 * recently added item may be removed from a stack.  There is no limit to the
 * number of items that may be placed on a stack.
 **/
public class Stack {

	private int size; //size of the stack 
	
	private ListNode top; //the top item of the stack
	
	/** 
	 * Creates a new, initially empty stack.
	 **/
	public Stack() { 
		top = null;
		size = 0;
	}
	

	/**
	 * Pops the top item off the stack.  If the stack is empty when this 
	 * method is called, an EmptyStackException is thrown.
	 * 
	 * @return the Object from the top of the stack
	 * @exception EmptyStackException thrown when the user tries to pop an
	 *            empty stack
	 **/
	public Object pop() throws EmptyStackException {
		if ( isEmpty() ) throw new EmptyStackException();
		Object temp = top.data;
		top = top.next;
		size--;
		return temp;
	}
	
	/**
	 * Returns the top item on the stack (but does not remove it).  If the 
	 * stack is empty when this method is called, an EmptyStackException is
	 * thrown.
	 * 
	 * @return the Object from the top of the stack
	 * @exception EmptyStackException thrown when the user tries to peek at  
	 *            the top item in an empty stack
	 **/
	public Object peek() throws EmptyStackException { 
		if (isEmpty() ) throw new EmptyStackException();
		return (top.data);
	}
	

	/**
	 * Pushes the given item onto the top of the stack.
	 *
	 * @param obj the Object to push onto the stack
	 **/
	public void push(Object obj) {
		top = new ListNode(obj, top);
		size++;
	}
	
	/**
	 * Is the stack empty?
	 * @return true if the stack is empty; false otherwise
	 **/
	public boolean isEmpty() { 
		if (size == 0) return true;
		else return false; 
	}

	
	/**
	 * Returns the number of items currently in the stack.
	 *
	 * @return number of items in the stack
	 **/
	public int size() { 
		return size;
	}
}
